import 'codemirror/addon/display/placeholder';
import 'codemirror/addon/edit/continuelist';
import 'codemirror/mode/gfm/gfm';
import { EditorFromTextArea } from 'codemirror';
import { ChangeDetectorRef, ElementRef, OnChanges, OnDestroy, OnInit, Renderer2, SimpleChanges } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { NtFormFieldControl } from '@ng-tangram/components/forms';
import { NtMarkdownEditorConfig } from './markdown-editor-config';
import { NtMarkdownEditorIcons } from './markdown-editor-icons';
export declare class NtMarkdownEditorComponent extends NtFormFieldControl<string> implements ControlValueAccessor, OnInit, OnChanges, OnDestroy {
    private _renderer;
    private _changeDetectorRef;
    private platformId;
    ngControl: NgControl;
    private readonly _destroy;
    private _syncScrollElements;
    private _syncScrollEvent;
    private _syncScrollSubscription;
    private _value;
    fillScreen: boolean;
    previewMode: boolean;
    instance: EditorFromTextArea;
    config: NtMarkdownEditorConfig;
    icons: NtMarkdownEditorIcons;
    activeActions: string[];
    activeActionsSnapshot: string[];
    _minHeight: string;
    _maxHeight: string;
    editor: ElementRef;
    markdown: ElementRef;
    set value(value: string);
    get value(): string;
    get empty(): boolean;
    private _focused;
    get focused(): boolean;
    placeholder: string;
    private _disabled;
    set disabled(value: boolean);
    get disabled(): boolean;
    private _required;
    get required(): boolean;
    set required(value: boolean);
    private _minRows;
    get minRows(): number;
    set minRows(value: number);
    private _maxRows;
    get maxRows(): number;
    set maxRows(value: number);
    private _theme;
    get theme(): string;
    set theme(value: string);
    get history(): {
        undo: number;
        redo: number;
    };
    private _onChange;
    private _onTouched;
    constructor(_renderer: Renderer2, _changeDetectorRef: ChangeDetectorRef, platformId: Object, ngControl: NgControl, _icons: NtMarkdownEditorIcons, _config: NtMarkdownEditorConfig);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    writeValue(value: any): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    focus(): void;
    setDisabledState(isDisabled: boolean): void;
    execCommand(type: string): void;
    undo(): void;
    redo(): void;
    changeScreenFilled(fillScreen: boolean): void;
    private _subscribeScrolls;
    private _unsubscribeScrolls;
    private _scrollTo;
    private _codeMirrorInit;
    private _onCodeMirrorChange;
    private _onCodeMirrorCursorActivity;
    private _onCodeMirrorFocus;
    private _onCodeMirrorBlur;
    private _actionMatches;
    private _setEditorHeightRange;
}
